//
//  Copyright (C) 2012 Vitor Rolla
//  vitorgr [at] dei.uc.pt
//  University of Coimbra - Portugal
//

#ifndef NETWORKLAYER_MOFO_MOFO_MESSAGEBLOCK_H
#define NETWORKLAYER_MOFO_MOFO_MESSAGEBLOCK_H

#include <stdexcept>

namespace MOFO{

class MOFO_MessageBlock
{
	protected:
		uint32_t msgId;
		uint8_t nOfCopies;
		uint8_t initNOfCopies;
		double msgCreationTime;

	public:

		MOFO_MessageBlock() : msgId(0), nOfCopies(0), initNOfCopies(0), msgCreationTime(0)
		{
		}

		MOFO_MessageBlock(const MOFO_MessageBlock& other)
		{
			operator=(other);
		}

		MOFO_MessageBlock& operator=(const MOFO_MessageBlock& other)
		{
			if (this==&other) return *this;
			this->msgId = other.msgId;
			this->msgCreationTime = other.msgCreationTime;
			this->nOfCopies = other.nOfCopies;
			this->initNOfCopies = other.initNOfCopies;
			return *this;
		}

		double getMsgCreationTime() const
			{
				//if (!hasRoute()) throw std::runtime_error("Tried to read Route from RouteBlock, but found none");
				return msgCreationTime;
			}


		void setMsgCreationTime(double msgCreationTime)
			{
				this->msgCreationTime = msgCreationTime;
			}

		uint8_t getNOfCopies() const
			{
				//if (!hasMessage()) throw std::runtime_error("Tried to read Message from MessageBlock, but found none");
				return nOfCopies;
			}
		uint8_t getInitNOfCopies() const
			{
				//if (!hasMessage()) throw std::runtime_error("Tried to read Message from MessageBlock, but found none");
				return initNOfCopies;
			}

		uint32_t getMsgId() const
			{
				//if (!hasMessage()) throw std::runtime_error("Tried to read Message from MessageBlock, but found none");
				return msgId;
			}

		void setMsgId(uint32_t id)
			{
				this->msgId = id;
			}

		void setNOfCopies(uint8_t copies)
			{
				this->nOfCopies = copies;
			}
		void setInitNOfCopies(uint8_t copies)
			{
				this->initNOfCopies = copies;
			}



};
}

typedef MOFO::MOFO_MessageBlock MOFOnet_MOFO_MessageBlock;

#endif

